DECLARE SUB rtprecalc (NsLUT() AS ANY, invmag!(), sph() AS ANY, XMIN%, XMAX%, ymax%, screenz%)
DECLARE SUB IsSphereHit (FHStatus() AS ANY, sph() AS ANY, spherenum%, Ns AS ANY, nscreenz!)
DECLARE SUB raytrace (pal() AS ANY)
DECLARE SUB SETgraypal ()
DECLARE FUNCTION ceil% (x!)
DECLARE FUNCTION floor% (x!)
DECLARE SUB normalize (x!, y!, z!)
DECLARE SUB cross (V1 AS ANY, V2 AS ANY, v AS ANY)
DECLARE FUNCTION maxidx% (w AS ANY)
DECLARE SUB ffix
ffix
'==============================================
'  * realtime sphere raytracer
'==============================================
CONST neveragain = -2
CONST offscanline = -1
CONST unknown = 0
CONST interval = 1
CONST onscanline = 2


CONST FPSTUN = 0
CONST FPSRAY = 1
CONST FPSLITE = 2

'screen is 'screendist' pixels in front of the eye
CONST pi = 3.14159265358979#
CONST ang180 = pi
CONST ang360 = pi * 2
CONST deg2rad = pi / 180

TYPE vec
	x AS SINGLE
	y AS SINGLE
	z AS SINGLE
END TYPE

DEFSNG A-Z
'----------constants for tunnel mapper---------------
CONST radius = 150
CONST screendist = 200
CONST tsize = 15
CONST tmask = 15
CONST xres = 320
CONST yres = 150
CONST invxres = 1! / xres
CONST invyres = 1! / yres
CONST tnxmax = xres - 1
CONST tnymax = yres - 1
CONST yh = (yres \ 2) - 1
CONST xh = (xres \ 2) - 1

DEFINT A-Z


TYPE paltype
	r AS INTEGER
	g AS INTEGER
	b AS INTEGER
END TYPE

TYPE spheretype
	x AS INTEGER
	y AS INTEGER   ' center of sphere
	z AS INTEGER
	r AS INTEGER   ' radius
	R2 AS LONG     ' radius^2
	invr AS SINGLE ' 1/radius
   
	L2 AS LONG '(length of ray from ray origin to sphere center)^2
	eyeoutsidesphere AS INTEGER
END TYPE


TYPE FHStatusType
	flag AS INTEGER
	IntervalL AS INTEGER
	IntervalR AS INTEGER
END TYPE



DIM SHARED fps!(0 TO 5)

'----------------main program------------------
SCREEN 13
CLS
'$DYNAMIC

DIM pal(255) AS paltype

CONST sxmax = 320, symax = 200
CONST sxctr = sxmax / 2, syctr = symax / 2
CONST XMIN = sxctr - sxmax
CONST XMAX = XMIN + sxmax - 1
CONST ymin = syctr - symax
CONST ymax = ymin + symax - 1
CONST szctr = symax
CONST numspheres = 6
CONST screenz = 150
CONST nscreenz = -screenz

CALL raytrace(pal())


REM $STATIC
DEFSNG A-Z
FUNCTION ceil% (x!)
ceil% = (x! + .499999) AND -1'=INT(x + .999999!)
END FUNCTION

SUB cross (V1 AS vec, V2 AS vec, v AS vec)
'vector V = V1 x V2
v.x = V1.y * V2.z - V2.y * V1.z
v.y = V2.x * V1.z - V1.x * V2.z
v.z = V1.x * V2.y - V2.x * V1.y
END SUB

FUNCTION floor% (x!)
floor% = INT(x!)
END FUNCTION

SUB IsSphereHit (FHStatus() AS FHStatusType, sph() AS spheretype, spherenum%, Ns AS vec, nscreenz)
'based on ideas and C code by Thomas Moller
'Purpose:
'   calculates whether sphere spherenum% will be hit on this scanline
'Params:
'   spherenum% - which sphere to use
'   Ns - normal of the scanline plane = (Right-Eye)x(Left-Eye)
'   Left - leftmost point on scanline
'Result:
'   fills FirstHitStatus() array
'throw away the coordinate
'that corresponds to max(Ns.x,Ns.y,Ns.z)
badidx% = maxidx(Ns)

signeddist = Ns.x * sph(spherenum%).x + Ns.y * sph(spherenum%).y + Ns.z * sph(spherenum%).z
IF signeddist > sph(spherenum%).r THEN
	' sphere is above the plane, so won't hit it anymore
	FHStatus(spherenum%).flag = neveragain
ELSEIF signeddist < -sph(spherenum%).r THEN
	' sphere is below the scanline plane
	FHStatus(spherenum%).flag = offscanline
ELSE
	'we might hit the sphere
	DIM d AS vec
	DIM h AS vec
	DIM Cc AS vec  'note: Cc is cut circle's center point
	DIM Nd AS vec
	'' vector CC = spherecenter - (signeddist * Ns )
	Cc.x = sph(spherenum%).x - signeddist * Ns.x
	Cc.y = sph(spherenum%).y - signeddist * Ns.y
	Cc.z = sph(spherenum%).z - signeddist * Ns.z
	''cr2=(Sr * Sr)- signeddist^2
	cr2 = sph(spherenum%).R2 - signeddist * signeddist
	'' vector D = CC-Eyepos
	d.x = Cc.x
	d.y = Cc.y
	d.z = Cc.z
	'' D2 = D dot D = (magnitude(D))^2
	d2 = d.x * d.x + d.y * d.y + d.z * d.z
	IF d2 <= cr2 THEN
		FHStatus(spherenum%).flag = onscanline
		EXIT SUB
	END IF
	'' H = D cross Ns
	CALL cross(d, Ns, h)
	t1 = cr2 / d2
	sintheta = SQR(t1)
	costheta = SQR(1 - t1)
	
	
		' .x=.y from case 1
			t1 = h.x * sintheta
			t2 = d.x * costheta
			V1u = t1 + t2
			V2u = t2 - t1
			t1 = h.z * sintheta
			t2 = d.z * costheta
			V1v = t1 + t2
			V2v = t2 - t1
			't1 = xmin 'Left.x
			't2 = nscreenz '-Left.z
			t3 = -V1v
			IF t3 <> 0! THEN
				'V1 is not parallel to scanline
				FHStatus(spherenum%).IntervalR = floor%((V1v * XMIN + V1u * nscreenz) / t3)
				t3 = -V2v
				IF t3 = 0 THEN
					FHStatus(spherenum%).IntervalL = 0
				ELSE
					FHStatus(spherenum%).IntervalL = ceil%((V2v * XMIN + V2u * nscreenz) / t3)
				END IF
			ELSE 'rare case when V1 is parallel to scanline
				t3 = -V2v
				FHStatus(spherenum%).IntervalL = ceil%((V2v * XMIN + V2u * nscreenz) / t3)
				FHStatus(spherenum%).IntervalR = 319
			END IF
   
	' check if interval is valid and set status
	IF ((FHStatus(spherenum%).IntervalL >= 320) OR (FHStatus(spherenum%).IntervalR < 0)) THEN
		FHStatus(spherenum%).flag = offscanline 'off screen to left or right
	ELSE
		IF (FHStatus(spherenum%).IntervalR >= 320) THEN FHStatus(spherenum%).IntervalR = 319
		IF (FHStatus(spherenum%).IntervalL < 0) THEN FHStatus(spherenum%).IntervalL = 0
		IF ((FHStatus(spherenum%).IntervalL = 0) AND (FHStatus(spherenum%).IntervalR = 319)) THEN
			FHStatus(spherenum%).flag = onscanline
		ELSE
			FHStatus(spherenum%).flag = interval
		END IF
	END IF
	IF (FHStatus(spherenum%).IntervalL > FHStatus(spherenum%).IntervalR) THEN
		FHStatus(spherenum%).flag = offscanline
	END IF
END IF
'' this implicitly returns FHstatus
END SUB

DEFINT A-Z
FUNCTION maxidx (w AS vec)
'Params:
'   W, the vector to find the max coordinate index of
'returns:
'   1 if W.x coordinate is greatest
'   2 if W.y coordinate is greatest
'   3 if W.z coordinate is greatest
				  MAX = ABS(w.x): tmaxidx = 1
IF (ABS(w.y) > MAX) THEN MAX = ABS(w.y): tmaxidx = 2
IF (ABS(w.z) > MAX) THEN MAX = ABS(w.z): tmaxidx = 3
maxidx = tmaxidx
END FUNCTION

DEFSNG A-Z
SUB normalize (x, y, z)
mag = SQR(x * x + y * y + z * z)
'should make this beep in debug mode
IF mag = 0 THEN
	x = 0
	y = 0
	z = 0
	EXIT SUB
END IF
x = x / mag
y = y / mag
z = z / mag
END SUB

DEFINT A-Z
SUB raytrace (pal() AS paltype)
' Realtime raytracer based on techniques in "Realtime Rendering"
' by Moller and Haines, and Moller's scanline rejection algorithm
' in "Graphics Gems," combined with subdivision techniques
' developed while creating my first raytracer. --Toshi

'---------constants for raytracer-----------------


CONST yofs = 20
CONST xofs = 19 'must be an odd number

CONST ysize = (ymax - 28 - (ymin + yofs) + 1)
CONST xsize = (XMAX - 84 - (XMIN + xofs) + 2)

'$DYNAMIC
DIM invmag!(0 TO 160, 0 TO 100)
DIM arr(2 + (ysize * xsize \ 2))
'DIM envmap(0 TO 63, 0 TO 63)
'$STATIC
DIM NsLUT(0 TO 199)  AS vec
DIM sph(1 TO numspheres)  AS spheretype
DIM FHStatus(1 TO numspheres)  AS FHStatusType

CALL rtprecalc(NsLUT(), invmag!(), sph(), XMIN, XMAX, ymax, screenz)
CLS

CALL SETgraypal

arr(0) = (xsize - 1) * 8
arr(1) = (ysize - 1)

frames = 0
t1! = TIMER

dz! = screenz
dz2! = dz! * dz!

DIM r ' reflected vector
DIM dv AS vec: DIM v0 AS vec
DIM n AS vec
DIM v AS vec

'for plane intersections
DIM pv AS vec
DIM pv0 AS vec
DIM pn AS vec
DIM Left AS vec

'added for fastSphereHit calcs
DIM Ns AS vec 'vector BExAE
Left.x = XMIN
DIM scanlinedir AS vec
Left.z = screenz
DIM hit(ymin TO ymax)
LOCATE 2, 7: COLOR 255: PRINT "---[ Realtime Raytracing ]---"
t! = TIMER
DO
	REDIM arr(2 + (ysize * xsize \ 2))
	arr(0) = xsize * 8
	arr(1) = ysize
	DEF SEG = VARSEG(arr(2))
	P& = VARPTR(arr(3))

	tt = INT(TIMER * 60) AND 32767
	FOR i = 1 TO numspheres
		FHStatus(i).flag = unknown
	NEXT i

	FOR i = 1 TO numspheres
		ctte! = COS((tt * .007 + i) * 2)
		xx = 150 * ctte!
		yy = 100 * SIN((tt * .007 + i) * 2)
		zz = 350 + 100 * ctte!
	   
		sph(i).x = xx
		sph(i).y = yy
		sph(i).z = zz
		sph(i).L2 = xx * xx + yy * yy + CLNG(zz) * zz
		'if eyeoutsidesphere is FALSE, ray guaranteed
		'to hit the sphere, since it's inside.
		'sph(i).eyeoutsidesphere = (sph(i).L2 > sph(i).r2)
	NEXT

	dz2! = dz! * dz!
	FOR y = ymin + yofs TO ymax - 28
		q& = P& + xsize
		yo = y + syctr
		dy! = y
		dyz2! = dy! * dy! + dz2!
		ay = ABS(y)
		lastisect = -1
		lastc = 0
		c = 0

		Ns = NsLUT(yo)
		Left.y = y

		hit(y) = 0
		leftxmin = 319
		rightxmax = 0
		FOR i = 1 TO numspheres
			IF FHStatus(i).flag <> neveragain THEN
				CALL IsSphereHit(FHStatus(), sph(), i, Ns, nscreenz)
				IF FHStatus(i).flag = interval THEN
					leftx = FHStatus(i).IntervalL
					IF leftxmin > leftx THEN leftxmin = leftx
					rightx = FHStatus(i).IntervalR + 2
					IF rightxmax < rightx THEN rightxmax = rightx
					hit(y) = 1
					'LINE (FHStatus(i).IntervalL, yo)-(FHStatus(i).IntervalR, yo), 253
				ELSEIF FHStatus(i).flag = onscanline THEN
					hit(y) = 1
					'LINE (0, yo)-(319, yo), 128
				END IF
			END IF
		NEXT i%
		minx = leftxmin AND (NOT 1)
		'LOCATE 1, 1: COLOR 255: PRINT yo, minx: k$ = INPUT$(1)
		'LINE (0, yo)-(minx, yo), 255
		IF hit(y) THEN
			FOR x = XMIN + xofs TO XMAX - 84 STEP 2
				IF x + 160 >= rightxmax THEN P& = q&: EXIT FOR
				dx! = x
			   
				IF x + 160 > minx THEN
				i! = invmag!(ABS(x), ay)
				dxn! = dx! * i!
				dyn! = dy! * i!
				dzn! = dz! * i!
			   
				'ray sphere intersection
				GOSUB raytest

				IF intersect THEN
					xi = x
					GOSUB getcolor
				END IF

				IF lastisect <> intersect THEN
					GOSUB tracemiddle
					IF intersect THEN
						GOSUB getcolor
					END IF
				ELSE
					xi = x - 1
					IF intersect THEN POKE P& - 1, (lastc + c) \ 2
					'IF intersect THEN PSET (xi + sxctr, yo), (lastc + c) \ 2
					lastc = c
					lastisect = intersect
				END IF
				END IF
				P& = P& + 2
			NEXT x
		ELSE
			'LINE (0, yo)-(xsize, yo), 80
			P& = P& + xsize
		END IF
		IF LEN(INKEY$) THEN exitflag = 1
	NEXT y
	PUT (xofs, yofs + 12), arr, PSET
	frames = frames + 1
	IF exitflag THEN EXIT DO
	tt = tt + 1
	
     
LOOP UNTIL exitflag
elapsed! = TIMER - t1!
LOCATE 1, 1: COLOR 255: PRINT frames / elapsed!
ERASE arr, invmag!, NsLUT, sph, FHStatus
'ERASE envmap
EXIT SUB


raytest:
			c = 0
			intersect = 0
			tmin! = 999999!
			dxx! = dx! + sxctr
			FOR i = 1 TO numspheres
				IF (FHStatus(i).flag = interval AND dxx! >= FHStatus(i).IntervalL AND dxx! <= FHStatus(i).IntervalR) THEN
				'OR FHStatus(i).flag = onscanline THEN
					'd = L dot D
					d! = sph(i).x * dxn! + sph(i).y * dyn! + sph(i).z * dzn!
					'IF d! < 0 THEN
					'    IF sph(i).eyeoutsidesphere THEN
					'        'sphere is behind ray origin
					'        ' so reject intersection
					'        GOTO skip
					'    END IF
					'END IF
					L2& = sph(i).L2
					m2! = L2& - d! * d!
					R2& = sph(i).R2
					IF m2! > R2& THEN
						'reject
						GOTO skip
					END IF
					q! = SQR(R2& - m2!)
					IF L2& > R2& THEN
						t! = d! - q!
					ELSE
						t! = d! + q!
					END IF
					IF t! < tmin! THEN
						tmin! = t!
						intersect = i
					END IF
				END IF
skip:
			NEXT i

RETURN



tracemiddle:
	'order matters
	lastc = c
	lastisect = intersect
	'since raytest overwrites intersect
	xi = x - 1
	dx! = xi
	i! = invmag!(ABS(xi), ay)
	dxn! = dx! * i!
	dyn! = dy! * i!
	dzn! = dz! * i!
	GOSUB raytest
RETURN



getcolor:
	 'position of collision in world coordinates
	 v0x! = tmin! * dxn!
	 v0y! = tmin! * dyn!
	 v0z! = tmin! * dzn!
			   
	'N = normal of the sphere at the collision point
	'N is normalized by the 1/r operation.
	 invr! = sph(intersect).invr
	 nx! = (v0x! - sph(intersect).x) * invr!
	 ny! = (v0y! - sph(intersect).y) * invr!
	 nz! = (v0z! - sph(intersect).z) * invr!
			   
	 'V is view vector (from eye to sphere)
	 'vx! = -dxn!: vy! = -dyn!: vz! = -dzn!
	 'ndoti2! = 2 * (nx! * vx! + ny! * vy! + nz! * vz!)

	 'New direction r = reflection of V about N.
	 'r.x = ndoti2! * nx! - vx!
	 'r.y = ndoti2! * ny! - vy!
	 'r.z = ndoti2! * nz! - vz!

	 c = nx! * nx! * 255 'cheap shading for now

	'smarter, good looking shading is possible using envmaps.
	'you can have infinite phong-like static lighting
	'at no extra calculation cost! You can even have
	'dynamic light rotation around a world axis for the cost
	'of a 2D bitmap rotation.
	'c = envmap(ABS(nx! * 62), ABS(nz! * 62))
   
	IF xi = x THEN
		POKE P&, c
	ELSE
		POKE P& - 1, c
	END IF
RETURN


END SUB

SUB rtprecalc (NsLUT() AS vec, invmag!(), sph() AS spheretype, XMIN, XMAX, ymax, screenz)


'precalc eye-scanline plane normal vectors
DIM BE AS vec 'vector Right-Eye
DIM AE AS vec 'vector Left-Eye
DIM Left AS vec  'leftmost pixel of scanline
DIM Right AS vec  'rightmost pixel of scanline
DIM Ns AS vec

Left.x = XMIN: Right.x = XMAX
Left.z = screenz: Right.z = screenz
AE.z = Left.z
BE.z = Right.z
AE.x = Left.x
BE.x = Right.x
FOR y% = 0 TO symax - 1
		Left.y = y% - syctr
		Right.y = y% - syctr
		AE.y = Left.y
		BE.y = Right.y
		CALL cross(BE, AE, Ns)
		CALL normalize(Ns.x, Ns.y, Ns.z)
		NsLUT(y%) = Ns
NEXT y%

dz! = screenz
dz2! = dz! * dz!
'precalc normalized eye vectors
FOR y = 0 TO ymax
   dy! = y
   dyz2! = dy! * dy! + dz2!
   FOR x = 0 TO XMAX
		dx! = x
		invmag!(x, y) = 1! / SQR(dx! * dx! + dyz2!)
	NEXT x
NEXT y

FOR i = 1 TO numspheres
	sph(i).r = ABS(20 * (4 - i)) + 3
	sph(i).R2 = CLNG(sph(i).r) * sph(i).r
	sph(i).invr = 1 / sph(i).r
NEXT

'create envmap texture
'FOR y = 0 TO 63
'yn! = y / 63!
'FOR x = 0 TO 63
'    xn! = x / 63!
'    envmap(x, y) = 255 - ((((xn! * xn!) + (yn! * yn!)) ^ 3) * 255)
'NEXT
'NEXT
''random specks in light source
'FOR i = 0 TO 128
'x = RND * 32: y = RND * 32
'c = envmap(x, y) + RND * 60 - 30
'IF c > 255 THEN c = 255
'IF c < 0 THEN c = 0
'envmap(x, y) = c
'NEXT
END SUB

SUB SETgraypal
FOR i = 0 TO 255
gray = i \ 4
OUT &H3C8, i
OUT &H3C9, gray
OUT &H3C9, gray
OUT &H3C9, gray
NEXT

END SUB

